diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
index 7686689ee..aa4fe23b9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -8,7 +8,9 @@ import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -79,13 +81,13 @@ public class HudComponentLog extends HudComponentMovable {
                 if (message.getMessage().startsWith("[CHAT] ")) return;
 
                 final @NotNull String ellipsis = "...";
-                final int ellipsisWidth = mc.font.getStringWidth(ellipsis);
+                final int ellipsisWidth = mc.font.stringWidth(ellipsis);
 
                 @NotNull String line = message.getMessage().replace("\n", "");
                 int acc = 0;
                 int c = 0;
                 for (; c < line.length(); c++) {
-                    final int cWidth = mc.font.getCharWidth(line.charAt(c));
+                    final int cWidth = mc.font.charWidth(line.charAt(c));
                     if (acc + cWidth + ellipsisWidth > WIDTH) {
                         break;
                     }
@@ -157,19 +159,19 @@ public class HudComponentLog extends HudComponentMovable {
         render(mc.font, x, y, lines, new float[] { 1.0f, 1.0f, 1.0f, 1.0f }, anchor);
     }
 
-    private void render(final @NotNull Font font, final int x, final int y, final @NotNull String @NotNull[] lines, final float @NotNull[] opacities, final @Nullable ComponentAnchor anchor) {
+    private void render(final @NotNull FontRenderer sr, final int x, final int y, final @NotNull String @NotNull[] lines, final float @NotNull[] opacities, final @Nullable ComponentAnchor anchor) {
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         for (int i = 0; i < lines.length; i++) {
             @NotNull String line = lines[i];
 
-            final int lineWidth = font.getStringWidth(line);
+            final int lineWidth = sr.stringWidth(line);
             if (anchor == null || anchor == ComponentAnchor.TOP_LEFT || anchor == ComponentAnchor.CENTER_LEFT || anchor == ComponentAnchor.BOTTOM_LEFT) {
-                font.drawStringWithShadow(line, x + PADDING, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+                FontHelper.render(Tessellator.instance, line, x + PADDING, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
             } else if (anchor == ComponentAnchor.TOP_CENTER || anchor == ComponentAnchor.CENTER || anchor == ComponentAnchor.BOTTOM_CENTER) {
-                font.drawStringWithShadow(line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+                FontHelper.render(Tessellator.instance, line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
             } else {
-                font.drawStringWithShadow(line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+                FontHelper.render(Tessellator.instance, line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT).setShadow().setColor(0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24)).call(sr);
             }
         }
         GL11.glDisable(GL11.GL_BLEND);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
index a698d9b3b..9293a7038 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
@@ -61,7 +61,7 @@ public class ScreenKeyboard extends Screen implements ITextField {
         Keyboard.enableRepeatEvents(true);
         if (parent != null) {
             parent.mc = mc;
-            parent.font = mc.font;
+            parent.fontRenderer = mc.font;
             parent.width = width;
             parent.height = height;
         }
@@ -231,17 +231,17 @@ public class ScreenKeyboard extends Screen implements ITextField {
 
         Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.render(mc, this, _x, _y, mx, my));
 
-        drawStringCentered(mc.font, editor.getText(), _x + keyboardWidth/2, _y - 20, 0xFFFFFF);
+        drawStringCenteredShadow(mc.font, editor.getText(), _x + keyboardWidth/2, _y - 20, 0xFFFFFF);
 
         boolean drawCursor = (cursorCounter / 6) % 2 == 0;
         if (drawCursor)
         {
-            int width = font.getStringWidth(editor.getText());
+            int width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText()));
             if (editor.getCursor() < editor.getText().length())
             {
-                width = font.getStringWidth(editor.getText().substring(0, editor.getCursor()));
+                width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText().substring(0, editor.getCursor())));
             }
-            drawString(font, "_", _x + keyboardWidth/2 - font.getStringWidth(editor.getText())/2 + width, _y - 20 + 1, 0xE0E0E0);
+            drawStringShadow(fontRenderer, "_", _x + keyboardWidth/2 - MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText())/2) + width, _y - 20 + 1, 0xE0E0E0);
         }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
index c6d8c92c1..29013ee1c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/CharKey.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui.keyboard.keys;
 
-import com.b100.utils.StringUtils;
 import com.google.gson.JsonArray;
 import com.google.gson.JsonDeserializationContext;
 import com.google.gson.JsonDeserializer;
@@ -20,9 +19,7 @@ import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 import java.lang.reflect.Type;
-import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.List;
 import java.util.Locale;
 
@@ -55,7 +52,7 @@ public class CharKey extends Key{
                 GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
                 GL11.glTranslatef(x + originX + 4, y + originY + 2, 0);
                 GL11.glScalef(0.75f, 0.75f, 1);
-                drawStringCentered(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? lastGroup.collections[0].upper : lastGroup.collections[0].lower), 0, 0, 0xE0E0E0);
+                drawStringCenteredShadow(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? lastGroup.collections[0].upper : lastGroup.collections[0].lower), 0, 0, 0xE0E0E0);
                 GL11.glPopMatrix();
             }
 
@@ -64,7 +61,7 @@ public class CharKey extends Key{
                 GL11.glColor4f(0.75f, 0.75f, 0.75f, 1f);
                 GL11.glTranslatef(x + width + originX - 4, y + originY + 2, 0);
                 GL11.glScalef(0.75f, 0.75f, 1);
-                drawStringCentered(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? nextGroup.collections[0].upper : nextGroup.collections[0].lower), 0, 0, 0xE0E0E0);
+                drawStringCenteredShadow(mc.font, String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? nextGroup.collections[0].upper : nextGroup.collections[0].lower), 0, 0, 0xE0E0E0);
                 GL11.glPopMatrix();
             }
         }
@@ -86,7 +83,7 @@ public class CharKey extends Key{
                 size,
                 TextureRegistry.getTexture("minecraft:gui/screen/keyboard/radial_background"));
 
-            drawStringCentered(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight()/2 + 4 + originY, texColor);
 
             final double dx;
             final double dy;
@@ -107,7 +104,7 @@ public class CharKey extends Key{
                 int charX = MathHelper.floor(x + originX + width/2d + Math.cos(r * i - Math.PI/2) * 20 * animProgress);
                 int charY = MathHelper.floor(y + originY + height/2d + Math.sin(r * i - Math.PI/2) * 20 * animProgress) - 3;
 
-                drawStringCentered(
+                drawStringCenteredShadow(
                     mc.font,
                     String.valueOf(keyboard.isModifierActive(ModifierKey.ID_MODIFIER_SHIFT) ? collection.upper : collection.lower),
                     charX,
@@ -117,7 +114,7 @@ public class CharKey extends Key{
             GL11.glDisable(GL11.GL_BLEND);
             GL11.glPopMatrix();
         } else {
-            drawStringCentered(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight/2 + 4 + originY, texColor);
+            drawStringCenteredShadow(mc.font, String.valueOf(getActiveChar(mc, keyboard, originX, originY, mouseX, mouseY)), x + width/2 + originX, y + mc.font.fontHeight()/2 + 4 + originY, texColor);
         }
         GL11.glColor4f(1f, 1f, 1f, 1f);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 5ce0c784d..3e9af8a67 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -15,20 +15,16 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Buffer;
-import net.minecraft.core.util.helper.Utils;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -245,7 +241,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
         buttons.addAll(leftSideButtons);
 
-        ListenerTextFieldElement rField = new ListenerTextFieldElement(this, font, 0, j++ * 21, 40, 20, String.valueOf(bgRed), "Red");
+        ListenerTextFieldElement rField = new ListenerTextFieldElement(this, fontRenderer, 0, j++ * 21, 40, 20, String.valueOf(bgRed), "Red");
         rField.setPrefaceText("R: ");
         rField.setKeyListener(key -> {
             try {
@@ -258,7 +254,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
                 bgRed = defaultRed;
             }
         });
-        ListenerTextFieldElement gField = new ListenerTextFieldElement(this, font, 40, rField.yPosition, 40, 20, String.valueOf(bgGreen), "Green");
+        ListenerTextFieldElement gField = new ListenerTextFieldElement(this, fontRenderer, 40, rField.yPosition, 40, 20, String.valueOf(bgGreen), "Green");
         gField.setPrefaceText("G: ");
         gField.setKeyListener(key -> {
             try {
@@ -271,7 +267,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
                 bgGreen = defaultGreen;
             }
         });
-        ListenerTextFieldElement bField = new ListenerTextFieldElement(this, font, 80, rField.yPosition, 40, 20, String.valueOf(bgBlue), "Blue");
+        ListenerTextFieldElement bField = new ListenerTextFieldElement(this, fontRenderer, 80, rField.yPosition, 40, 20, String.valueOf(bgBlue), "Blue");
         bField.setPrefaceText("B: ");
         bField.setKeyListener(key -> {
             try {
@@ -384,7 +380,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
 //        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
-        drawStringCentered(font, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
     @Override
     public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
index 59b149d99..6fcd2c098 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerTextFieldElement.java
@@ -4,11 +4,12 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 
 public class ListenerTextFieldElement extends ListenerButtonElement implements ITextField {
-    private final Font font;
+    private final FontRenderer fontRenderer;
     private String text = "";
     private String prefaceText = "";
     private int maxStringLength;
@@ -22,14 +23,14 @@ public class ListenerTextFieldElement extends ListenerButtonElement implements I
     public boolean drawBackground = true;
     public final TextFieldEditor editor;
 
-    public ListenerTextFieldElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
+    public ListenerTextFieldElement(Screen parent, FontRenderer fontRenderer, int xPosition, int yPosition, int width, int height, String defaultText, String placeholder)
     {
         super(-1, xPosition, yPosition, width, height, "");
         playSound = false;
         isFocused = false;
         isEnabled = true;
         this.parent = parent;
-        this.font = font;
+        this.fontRenderer = fontRenderer;
         this.editor = new TextFieldEditor(this);
         this.placeholder = placeholder;
         setText(defaultText);
@@ -118,24 +119,24 @@ public class ListenerTextFieldElement extends ListenerButtonElement implements I
         }
         if (text.isEmpty() && !isFocused)
         {
-            drawString(font, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
+            drawStringShadow(fontRenderer, placeholder, xPosition + 4, yPosition + (height - 8) / 2, 0x5f5f5f);
         }
 
         if(isEnabled)
         {
             boolean drawCursor = isFocused && (cursorCounter / 6) % 2 == 0;
             int cursor = editor.getCursor();
-            int maxDisplayableChars = this.width / font.getCharWidth('_');
+            int maxDisplayableChars = this.width / fontRenderer.charWidth('_');
 
             if (!text.isEmpty() || isFocused){
                 if(prefaceText.length() + text.length() <= maxDisplayableChars-1){
-                    drawString(font, prefaceText + text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                    drawStringShadow(fontRenderer, prefaceText + text, xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
                 } else {
                     //only draw the part of the string that's maxDisplayableChars chars around the cursor
                     String newString = prefaceText + text;
                     int begin = Math.max(0,cursor - maxDisplayableChars);
                     int end = Math.max(maxDisplayableChars,Math.min(newString.length(),cursor));
-                    drawString(font, newString.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
+                    drawStringShadow(fontRenderer, newString.substring(begin, end), xPosition + 4, yPosition + (height - 8) / 2, 0xE0E0E0);
                 }
             }
             if (drawCursor)
@@ -144,21 +145,21 @@ public class ListenerTextFieldElement extends ListenerButtonElement implements I
                 if (!text.isEmpty() || isFocused){
                     currentText = prefaceText + text;
                 }
-                int width = font.getStringWidth(currentText);
+                int width = MathHelper.ceil(fontRenderer.stringWidthDouble(currentText));
                 if (cursor < text.length())
                 {
-                    width = font.getStringWidth(text.substring(0, cursor)) + font.getStringWidth(prefaceText);
+                    width = MathHelper.ceil(fontRenderer.stringWidthDouble(text.substring(0, cursor)) + fontRenderer.stringWidthDouble(prefaceText));
                 }
                 if(width >= this.width-4){
                     // width of the text box - the width of the last character
-                    width = (this.width-4) - font.getStringWidth(currentText.substring(currentText.length()-2,currentText.length()-1));
+                    width = (this.width-4) - MathHelper.ceil(fontRenderer.stringWidthDouble(currentText.substring(currentText.length()-2,currentText.length()-1)));
                 }
-                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawStringShadow(fontRenderer, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
             }
         }
         else
         {
-            drawString(font, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
+            drawStringShadow(fontRenderer, text, xPosition + 4, yPosition + (height - 8) / 2, 0x707070);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
index 7eff42c73..e6bf19dd0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/elements/TextCycleElement.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.modelviewer.elements;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Screen;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
 
 public abstract class TextCycleElement<T> extends ListenerButtonElement {
     private T currentElement;
@@ -10,10 +10,10 @@ public abstract class TextCycleElement<T> extends ListenerButtonElement {
     public final ListenerButtonElement prevButton;
     public final ListenerButtonElement nextButton;
     public final ListenerTextFieldElement textField;
-    public TextCycleElement(Screen parent, Font font, int xPosition, int yPosition, int width, int height, T initialElement) {
+    public TextCycleElement(Screen parent, FontRenderer sr, int xPosition, int yPosition, int width, int height, T initialElement) {
         super(-1, xPosition, yPosition, width, height, "");
 
-        textField = new ListenerTextFieldElement(parent, font, 0, yPosition, width - height * 2 - 2, height, getNameFromElement(initialElement), "");
+        textField = new ListenerTextFieldElement(parent, sr, 0, yPosition, width - height * 2 - 2, height, getNameFromElement(initialElement), "");
         textField.setKeyListener(key -> {
             String text = textField.getText();
             setCurrentElement(getElementFromString(text));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 2731a54a4..6784fb64e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -128,7 +128,7 @@ public class ScreenOptions
                 textColor = 0xFFFFFFA0;
             }
             renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
-            mc.font.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            drawStringShadow(this.fontRenderer, translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
             y2 += PAGE_BUTTON_HEIGHT;
         }
     }
@@ -303,7 +303,7 @@ public class ScreenOptions
         overlayBackground(pagesListWidth, pagesListWidth + SEPARATOR_WIDTH, top, bottom);
 
         String titleLanguageKey = "gui.options.title";
-        drawStringCentered(font, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
 
         drawOptionsScrollBar(mx, my);
         drawPagesListScrollBar(mx, my);
@@ -312,7 +312,7 @@ public class ScreenOptions
 
         if (pickingKeyBinding != null && pickingKeyBindingComponent != null) {
             drawRect(0, 0, width, height, 0xA0000000);
-            drawStringCenteredNoShadow(font, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), width / 2, height / 2 - 4, 0xffffff);
+            drawStringCenteredNoShadow(fontRenderer, i18n.translateKeyAndFormat("gui.options.label.picking_keybinding", i18n.translateKey(pickingKeyBinding.getId())), width / 2, height / 2 - 4, 0xffffff);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index 0634b81e7..ebd819aa1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -6,11 +6,11 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
@@ -73,7 +73,7 @@ public class AvailableTexturePackListComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         if (availablePacks.isEmpty()) {
-            mc.font.drawCenteredString(I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4, 0x5F7F7F7F);
+            FontHelper.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.texture_packs.label.no_packs"), x + width / 2, y + 4).setShadow().setColor(0x5F7F7F7F).call(mc.font);
         }
         for (int i = 0; i < availablePacks.size(); i++) {
             TexturePackButton button = availablePacks.get(i);
@@ -127,7 +127,6 @@ public class AvailableTexturePackListComponent
 
         public void render(int x, int y, int width, int mouseX, int mouseY, int index, boolean hovered) {
             Tessellator tessellator = Tessellator.instance;
-            Font font = mc.font;
 
             setupButton(x, y, width, mouseX, mouseY);
 
@@ -170,21 +169,21 @@ public class AvailableTexturePackListComponent
 
 			if(format == Global.TEXTURE_PACK_FORMAT) {
 				// Correct version
-				font.drawString(texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				font.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
-				font.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
 			}else if(format == -1) {
 				// Manifest error
-				font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				font.drawString(texturePack.manifest.getDescriptionLine1(), x + height + 2, y + 12, 0x808080);
-				font.drawString(texturePack.manifest.getDescriptionLine2(), x + height + 2, y + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}else {
 				// Wrong texture pack version
 				I18n i18n = I18n.getInstance();
-				font.drawString(TextFormatting.RED + texturePack.manifest.getName(), x + height + 2, y + 1, 0xFFFFFF);
-				font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + height + 2, y + 12, 0x808080);
-				font.drawString(i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + height + 2, y + 22, 0x808080);
+                FontHelper.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call(mc.font);
+                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.1"), x + this.height + 2, y + 12).setColor(0x808080).call(mc.font);
+                FontHelper.render(Tessellator.instance, i18n.translateKey("gui.options.page.texture_packs.label.outdated_pack.2"), x + this.height + 2, y + 22).setColor(0x808080).call(mc.font);
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}
 
@@ -194,8 +193,8 @@ public class AvailableTexturePackListComponent
             }
 
             String version = texturePack.manifest.getPackVersion();
-            int versionWidth = font.getStringWidth(version);
-            font.drawString(texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1, rgbVersion);
+            int versionWidth = mc.font.stringWidth(version);
+            FontHelper.render(Tessellator.instance, texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1).setColor(rgbVersion).call(mc.font);
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
             button.setX(x + width - button.width - 1);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index 762dff32c..db2477777 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
@@ -42,16 +42,15 @@ public abstract class ButtonComponent
     @Override
     public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        Font fr = mc.font;
         String translated = I18n.getInstance().translateKey(translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
-        fr.drawStringWithShadow(translated, x, y + (getHeight() / 2) - 4, textColor);
+        FontHelper.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call(mc.font);
         resetButton.enabled = !isDefault();
         renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
-        int stringWidth = fr.getStringWidth(translated);
+        int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
         if (resetButton.enabled) lineMaxX -= 20;
         drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
